//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
#property indicator_color3  Silver
#property indicator_color4  Red
#property indicator_style1  STYLE_DOT
#property indicator_style2  STYLE_DOT
#property indicator_style4  STYLE_DOT
#property indicator_width3  2

//
//
//
//
//

extern int    StoKPeriod = 144;
extern int    StoDPeriod =  3;
extern int    StoSlowing =  3;
extern int    SignalMode = MODE_EMA;
extern int    StoPrice   =  0;
extern int    LongPeriod = 50;
extern double Percent    = 95;

//
//
//
//
//

double sto[];
double sig[];
double leu[];
double led[];

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
// 
//
//
//
//

int init()
{
   SetIndexBuffer(0,leu);
   SetIndexBuffer(1,led);
   SetIndexBuffer(2,sto);
   SetIndexBuffer(3,sig);
      IndicatorShortName("Stochastic ("+StoKPeriod+","+StoDPeriod+","+StoSlowing+")");
   return(0);
}
int deinit() { return(0); }


//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,limit,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--) 
   {
      sto[i] = iStochastic(NULL,0,StoKPeriod,StoDPeriod,StoSlowing,SignalMode,StoPrice,MODE_MAIN  ,i);
      sig[i] = iStochastic(NULL,0,StoKPeriod,StoDPeriod,StoSlowing,SignalMode,StoPrice,MODE_SIGNAL,i);
            double hi = sto[ArrayMaximum(sto,LongPeriod,i)];
            double lo = sto[ArrayMinimum(sto,LongPeriod,i)];
            double rn = hi-lo;
      leu[i] = lo+rn*Percent/100.0;
      led[i] = hi-rn*Percent/100.0;
   }      
   return(0);
}